program gopart;
uses dos,crt,tools;

{Written by Hunter Beanland - 1999 - www.geocities.com/hbeanland }

var
  regs:registers;
  i,k : byte;
  n:integer;
  j : 0..3;
  switches,line:string;
  buffer : array[0..512] of byte;
  fatfound,afound,nopart,fat32d,xbool1,xbool2,xbool3,xbool4 : boolean;
  xbyte : byte;
  xlong,xlong2 : longint;
  xword : word;

procedure parttype(part:byte);
begin
  buffer[$01BE + 4]:=part;
    Writeln(#10'Updating...');
    with regs do begin
         ah:=03;  {write}
         dl:=$80; {drive}
         dh:=0;  {head}
         ch:=0;  {track}
         cl:=1; {sector}
         al:=1;  {# of sectors}
         es:=seg(buffer);
         bx:=ofs(buffer);
         intr($13,regs);
    end;
    writeln('Done. Please reboot.');
    halt;
end;

begin
  writeln('Gateway GoBack Partition Protection Enabler/Disabler 1.0');
  writeln('Copyright 2000  Gateway Pty Ltd');
  writeln(#10'GoBack must be not be running in order to run this utility');
  writeln('This is non-destructive, but you should backup data before proceeding!');
  writeln('Original partition must be FAT32 LBA');
  writeln('Syntax: GoPart /enable | /disable | /custom xx');
  line:='';
  if paramcount>0 then switches:=paramstr(1);
  upstr(switches);
  fat32d:=false;
  afound:=false;
  nopart:=false;
  fatfound:=false;
  i:=$80;
  xbool1:=false;
  xbool2:=false;
  writeln(#10'Disk 1 Partitions:');
  repeat
    with regs do begin
      AX:=$0201;
      CX:=$0001;
      DX:=i;
      ES:=seg(buffer);
      BX:=ofs(buffer);
      intr($13, regs);
      if regs.flags and fcarry = $0000 then begin
        xbool1:=true;
        xbool2:=true
      end
      else
        if i < $99 then inc(i)
        else xbool1:=true
      end
  until xbool1;
  if xbool2 then begin
    xbool3:=false;
    repeat
      for j:=0 to 3 do begin
        xword:=$01BE + j shl 4;
        xbyte:=buffer[xword + 4];
        if xbyte > $00 then begin
          write(j+1,': ');
          case xbyte of
            $01 : line:='FAT12';
            $02,$03 : line:='XENIX';
            $04 : line:='FAT16';
            $05 : line:='Extended';
            $06 : line:='Big FAT16';
            $07 : line:='NTFS';
            $0A : line:='OS/2 Boot Manager';
            $0B : line:='FAT32';
            $0C : line:='FAT32 LBA';
            $0E : line:='FAT16 LBA';
            $0F : line:='Extended';
            $11 : line:='Hidden FAT12';
            $14,$16 : line:='Hidden FAT16';
            $17 : line:='Hidden NTFS';
            $1B : line:='Hidden FAT32';
            $1C : line:='Hidden FAT32 LBA';
            $1E : line:='Hidden FAT16 LBA';
            $1F : line:='Hidden Extended';
            $44 : line:='Gateway GoBack FAT32';
            $50,$53,$54 : line:='DiskManager';
            $51 : line:='Netware/DiskMan';
            $55 : line:='EZ-Drive';
            $64..$69 : line:='Netware';
            $81,$82,$83,$85 : Write('Linux');
            $86 : line:='FAT16 Stripe/Volume';
            $87 : line:='NTFS Stripe/Volume';
            $C6,$C7 : line:='Corrupt NT';
            $E3 : line:='FAT Read Only';
            $FF : line:='Hidden';
          else line:='Unknown: '+hex(xbyte,2);
          end;
        write(line);
        if line='FAT32 LBA' then fatfound:=true;
        if (pos('GoBack',line)>0) and (j=0) then fat32d:=true;
        xbyte:=buffer[xword];
        write(', ');
        case xbyte of
          $00 : write('Not Active');
          $80 : begin write('Active'); if i=$80 then afound:=true; end;
        else
            write('Status ',hex(xbyte, 2),'?')
        end;
          xbyte:=buffer[xword + 6];
{          xlong2:=0;
          for k:=11 downto 8 do
            xlong2:=xlong2 shl 8 + buffer[xword + k];}
          xlong:=0;
       for k:=15 downto 12 do
            xlong:=xlong shl 8 + buffer[xword + k];
          writeln(', ',longint(xlong div 2048),'Mb');
        end
        else if (i=$80) and (j=0) then nopart:=true;
      end; {4 prtn}
      xbool4:=false;
      repeat
        if i < $99 then begin
          inc(i);
        {  with regs do begin            don't need this bit for this prog
            AX:=$0201;
            CX:=$0001;
            DX:=i;
            ES:=seg(buffer);
            BX:=ofs(buffer);
            intr($13, regs);
            if regs.flags and fcarry = $0000 then begin
              xbool4:=true;
              writeln(#10'Disk 2 Partitions:');
            end
          end}
        end
        else begin
          xbool3:=true;
          xbool4:=true;
        end
      until xbool4;
    until xbool3
    end
  else begin
    writeln('Can''t find the hard drive!');
    exit;
  end;
  if not afound then writeln('WARNING: No Active partition found.');
  if nopart then writeln('No partitions found.');
  if (switches='/DISABLE') and fat32d then parttype($0c);
  if (switches='/ENABLE') and fatfound then parttype($44);
  if paramcount>1 then begin
    val(paramstr(2),i,n);
    if switches='/CUSTOM' then parttype(i);
  end;
  if switches='' then writeln(#10'Use command line switches to modify partition.');
  if (switches<>'/ENABLE') and (switches<>'/DISABLE') and (switches<>'/CUSTOM') then writeln('Invalid switch');
end.
